// MHash.cpp : implementation file
//

#include "stdafx.h"
#include "MHash.h"

#if SUPPORT_SHA1
	#include "sha1.h" 
#endif
#if SUPPORT_MD5 
	#include "md5.h" 
#endif

// MHash class
MHash::MHash()
{
	// Set some variables for defaultness
//	hashFile = "";
	tempHash.Empty();
}

// Hash with MD5
CString MHash::MD5Hash(CString inHashFile)
{
#if SUPPORT_MD5
	// Common variables
	FILE *fileToHash = NULL;
	unsigned long lenRead = 0;

	// The outputted File
	CString outFile;

	// Temporary working buffers
	unsigned char* tempOut = new unsigned char[256];
	CString tempHash = "";

	// MD5 object to work with
	MD5_CTX m_md5;

	// Check what operation we're doing
	// Hash a file
		if (inHashFile.IsEmpty()) return "";

		if (md5file(inHashFile.GetBuffer(MAX_PATH), 0, &m_md5))
		{
			for (int i = 0; i < 16; i++)
			{
				char tmp[3];
				_itoa(m_md5.digest[i], tmp, 16);
				if (strlen(tmp) == 1)
				{
					tmp[1] = tmp[0];
					tmp[0] = '0';
					tmp[2] = '\0';
				}
				tempHash += tmp;		
			}
		}
		outFile = tempHash;


	delete[] tempOut;

#endif
	return outFile;
}
// End MD5Hash //////////////////////////////////////////////////



// Hash with SHA-1
CString MHash::SHA1Hash(CString inHashFile)
{
#if SUPPORT_SHA1
	// Common variables
	FILE *fileToHash = NULL;
	unsigned char fileBuf[SIZE_OF_BUFFER];
	unsigned long lenRead = 0;

	// The outputted hash
	CString outFile;

	// Temporary working buffers
	unsigned char* tempOut = new unsigned char[256];

	// SHA-1 object
	sha1_ctx m_sha1;

	// Check what operation we're doing
	// Hash a file
		if (inHashFile.IsEmpty()) return "";
		sha1_begin(&m_sha1);

		fileToHash = fopen(inHashFile, "rb");
	
		do
		{
			lenRead = fread(fileBuf, 1, SIZE_OF_BUFFER, fileToHash);
			if(lenRead != 0)
			{
				sha1_hash(fileBuf, lenRead, &m_sha1);
			}
		} while (lenRead == SIZE_OF_BUFFER);

		fclose(fileToHash); fileToHash = NULL;

		sha1_end(tempOut, &m_sha1);

	for (int i = 0 ; i < 20 ; i++)
	{
		char tmp[3];
		_itoa(tempOut[i], tmp, 16);
		if (strlen(tmp) == 1)
		{
			tmp[1] = tmp[0];
			tmp[0] = '0';
			tmp[2] = '\0';
		}
		tempHash += tmp;	

	}

	delete[] tempOut;

	outFile = tempHash;
#endif
	return outFile;
}
// End MHash.cpp /////////////////////////////////////////////////
