// UITestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "UITest.h"
#include "UITestDlg.h"
#include "MSS_Setup.h"
#include "MSS_Options.h"
#include <fstream.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString sInFile;
CString sOutFile;
int iCrypto;
int iSlider;
BOOL bVerbose;

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CUITestDlg dialog

CUITestDlg::CUITestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUITestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUITestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUITestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUITestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUITestDlg, CDialog)
	//{{AFX_MSG_MAP(CUITestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnShowProperties)
	ON_BN_CLICKED(IDC_BUTTON2, OnProcessFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CUITestDlg message handlers

BOOL CUITestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUITestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUITestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUITestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUITestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
}

CString CUITestDlg::OnGetProperties() 
{
	CString sGetConfig;
	sGetConfig = "<properties>\n";
	sGetConfig += "\t<setup>\n";
	sGetConfig = sGetConfig + "\t\t<inputfile>" + sInFile + "</inputfile>\n";
	sGetConfig = sGetConfig + "\t\t<outputfile>" + sOutFile + "</outputfile>\n";
	if (iCrypto == 1)
		sGetConfig = sGetConfig + "\t\t<type>" + SHA1_Str + "</type>\n";
	else if (iCrypto == 2)
		sGetConfig = sGetConfig + "\t\t<type>" + MD5_Str + "</type>\n";
	else
		sGetConfig = sGetConfig + "\t\t<type>" + "UNKNOWN" + "</type>\n";
	sGetConfig += "\t</setup>\n";
	sGetConfig += "\t<options>\n";
	if (bVerbose)
		sGetConfig += "\t\t<log verbose = \"true\"/>\n";
	else
		sGetConfig += "\t\t<log verbose = \"false\"/>\n";
	CString sMinFileSize;
	sMinFileSize.Format("%d", iSlider);
	sGetConfig += "\t\t<minsize>" + sMinFileSize + "</minsize>\n";
	sGetConfig += "\t</options>\n";
	sGetConfig += "</properties>\n";
	return sGetConfig;

}
void CUITestDlg::OnShowProperties() 
{
	CPropertySheet sheet("MSS Component");
	MSS_Setup SetupPage;
	MSS_Options OptionsPage;
	sheet.AddPage(&SetupPage);
	sheet.AddPage(&OptionsPage);
//	sheet.SetModified ();
	int nResponse = sheet.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
		CString stemp = this->OnGetProperties();
		fstream xmlSFile("myProperties.xml",ios::out);
		xmlSFile << stemp;
		xmlSFile.close();
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
}

void CUITestDlg::OnProcessFile() 
{
	CString sOut;
	if (iCrypto == 1)
		sOut = hashObj.SHA1Hash(sInFile);
	else if (iCrypto == 2)
		sOut = hashObj.MD5Hash(sInFile);
	else
		sOut = "!!! No Cryptographic method selected"; 

	fstream xml_file(sOutFile,ios::out);
	xml_file << "<file ";
	xml_file << "input = \"" << sInFile << "\" ";
	xml_file << "output = \"" << sOutFile << "\" ";
	if (iCrypto == 1)
		xml_file << "type = \"" << SHA1_Str << "\">" << endl;
	else if (iCrypto == 2)
		xml_file << "type = \"" << MD5_Str << "\">" << endl;
	else
		xml_file << "type = \"" << "UNKNOWN" << "\">" << endl;
	xml_file << "\t<hash>" << sOut << "</hash>" << endl;
	xml_file << "</file>" << endl;
	xml_file.close();
/*
	// XmlTextWriter is in the .NET environment
	XmlTextWriter writer = new  XmlTextWriter("Crypto.xml", Encoding::ASCII);
	writer.WriteStartElement("file","");
	writer.WriteAttributeString("input", "test.txt");
	writer.WriteAttributeString("output", "Crypto.sha1");
	writer.WriteAttributeString("type", "sha1");
	writer.WriteStartElement("hash","");
	writer.WriteString(sOut);
	writer.WriteEndElement();
	writer.WriteEndElement();
	writer.WriteEndDocument();
*/
}


